<template>
  <v-ons-page>
    <!-- {{ getAppState.data.transactions }} -->
    <!-- <div v-if="!getAppState">Loading...</div> -->
    <!-- <div class="wallet-view-container" v-else> -->
    <div class="wallet-view-container">
      <!-- {{ getAppState }} -->
      <div class="total-balance">
        <h1 v-if="getAppState">{{ getAppState.data.balance }} Coin</h1>
        <h1 v-else>LOADING...</h1>
      </div>
      <div class="total-balance">
        <h4 v-if="getAppState">@{{ getWallet.handle }}</h4>
      </div>
      <div class="wallet-action-container">
        <div class="wallet-action">
          <v-ons-icon icon="ion-ios-download" size="lg" @click="$router.push('/wallet/receive')"></v-ons-icon>
          <p>Receive</p>
        </div>
        <div class="wallet-action">
          <v-ons-icon icon="ion-ios-send" size="lg" @click="$router.push('/wallet/send')"></v-ons-icon>
          <p>Send</p>
        </div>
        <div class="wallet-action">
          <v-ons-icon icon="ion-ios-gift" size="lg" @click="$router.push('/wallet/claim')"></v-ons-icon>
          <p>Claim</p>
        </div>
      </div>
      <v-ons-list>
        <v-ons-list-item
          v-for="transaction in transactions"
          :key="transaction.type + transaction.amount + transaction.timestamp"
        >
          <transaction-list-item :transaction="transaction" />
        </v-ons-list-item>
      </v-ons-list>
    </div>
  </v-ons-page>
</template>

<script>
import TransactionListItem from "~/components/TransactionListItem";
import { mapGetters, mapActions } from "vuex";
import utils from "../assets/utils";
export default {
  components: {
    TransactionListItem
  },
  data: function() {
    return {};
  },
  computed: {
    ...mapGetters({
      getWallet: "wallet/getWallet",
      getAppState: "chat/getAppState",
      isUIReady: "chat/isUIReady"
    }),
    transactions() {
      if (!this.getWallet || !this.getAppState) return [];
      let myAddress = this.getWallet.entry.address;
      let txs = this.getAppState.data.transactions;
      return txs.map(tx => {
        let type;
        let otherPersonAddress;
        if (tx.type === "transfer") {
          if (tx.srcAcc == myAddress && tx.tgt == myAddress) type = "self";
          else if (tx.srcAcc == myAddress) {
            type = "send";
            otherPersonAddress = tx.tgtAcc
          } else if (tx.tgtAcc == myAddress) {
            type = "receive";
             otherPersonAddress = tx.srcAcc
          } else type = "claim";
        } else {
          type = tx.type;
        }
        return {
          type,
          otherPersonAddress,
          timestamp: tx.timestamp,
          amount: tx.amount
        };
      });
    }
  }
};
</script>

<style>
.nuxt-link {
  width: 100%;
}
.total-balance {
  font-weight: 300;
  text-align: center;
  margin: 30px auto;
}
.total-balance h1 {
  font-weight: lighter;
}
.new-message-btn {
  margin: 20px auto;
  width: 100%;
  text-align: center;
  font-size: 13px;
  cursor: pointer;
}
.wallet-action-container {
  display: flex;
  justify-content: space-around;
  margin-bottom: 30px;
  max-width: 600px;
  margin: 20px auto;
}
.wallet-action {
  display: flex;
  flex-direction: column;
  justify-content: center;
  display: flex;
  flex-direction: column;
  justify-content: center;
  color: #0076ff;
}
.wallet-action ons-icon {
  text-align: center;
}
.list {
  max-width: 600px;
  margin: 0 auto;
}
</style>
